require "mapstuff"
require "player"

function love.load()
    winW = love.graphics.getWidth( )
    winH = love.graphics.getHeight( )
    --Set background color to white.. might replace it with a image later
    love.graphics.setBackgroundColor(0,0,0)
    background = love.graphics.newImage("/graphics/background.png")
    backend = love.graphics.newImage("/graphics/endsplash.png")

    status = love.graphics.newImage("/graphics/status.png")
    status2 = love.graphics.newImage("/graphics/status2.png")
    status3 = love.graphics.newImage("/graphics/status3.png")


    
    sound = love.audio.newSource("/sounds/paper.wav", "static") 
    death = love.audio.newSource("/sounds/death.wav", "static")
    win = love.audio.newSource("/sounds/weee.wav", "static")

    imageTiles = love.graphics.newImage("/graphics/tiles.png")
    tiles = loadtiles(imageTiles)
    
    currentMap = 1 --the map we are loading
    gameOn = true
    p = {}
    startLevel()
    p.img = love.graphics.newImage("/graphics/player.png")
    p.w = p.img:getWidth()
    p.h = p.img:getHeight()

    timer = 0
    timerU = true 

end


function startLevel()
    print(currentMap)
    if currentMap == 11 then
        timer = -100
        gameOn = false
        return
    end
    
    p.x = 300 --xloc 
    p.xv = 0 --xvelocity
    p.y = 200 --yloc
    p.yv = 0 --yvelocity
    p.fall = true --is player falling?
    p.dir = "left"
    p.rot = 0

    gravity = {}
    gravity.dir = "down"
    gravity.power = 1

    selectedItem = 0
    
    map, items = loadMap(currentMap)

    gameOn = false
    timer = 0
    timerU = true 
end



function love.draw()
    love.graphics.setColor(255,255,255,255)

    if timer == -100 then
        --this means you've won
        --too lasy to make a new variable...s
        love.graphics.draw(backend, 0,0)

        
    else
    love.graphics.setColor(255,255,255,255)
    love.graphics.draw(background, 0,0)
    love.graphics.draw(status,0,520)

    --love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 10)

    --draw player
    love.graphics.draw(p.img, math.floor(p.x), math.floor(p.y),math.rad(p.rot),1,1,math.floor(p.w/2),math.floor(p.h))

    love.graphics.rectangle("fill",p.x , p.y,1,1)

    --draw map
    love.graphics.setColor(255,255,255,255)
    drawMap(map,tiles)
    --drawItems
    

    if selectedItem ~= 0 then
        love.graphics.draw(status2,0,520)
        if love.mouse.getY() > 0 and love.mouse.getY() < 520 then
            love.graphics.drawq(imageTiles, tiles[tonumber(selectedItem)], (math.floor(love.mouse.getX()/40))*40,(math.floor(love.mouse.getY()/40))*40)
        else
            love.graphics.drawq(imageTiles, tiles[tonumber(selectedItem)], love.mouse.getX(), love.mouse.getY())
        end
    else
        love.graphics.draw(status,0,520)
    end

    if items[1] == nil then
        love.graphics.draw(status3,0,520)
    end

    local x = 60
    local y = 542
    for i,v in ipairs(items) do 
        love.graphics.drawq(imageTiles, tiles[tonumber(v)], x, y)
        x = x + 50
    end
    if not gameOn then
        love.graphics.setColor(0,0,0,timer)
        love.graphics.rectangle("fill",0 , 0,800,600)
    end
    love.graphics.setColor(255,0,0,255)

    end
end


function love.update(dt)
    if gameOn then
        fall(dt)
        move(dt)
        checkColli()

        if not onScreen() then
            startLevel()
            love.audio.stop(death)
            love.audio.play(death)
            gameOn = false
            timer = 0
            timerU = true
        end
    elseif timer ~= -100 then
        if timerU then
            timer = timer +2000*dt
            if timer >= 255 then
                timer = 255
                timerU = false
            end
        else
            timer = timer -1000*dt
            if timer <= 1 then
                gameOn = true
            end
        end
    end
end

function onScreen()
    if p.x > -50 and p.x < 850 then
        if p.y > -50 and p.y < 650 then
            return true
        end
    end
    return false
end

function love.keypressed(key)
    if key == "r" then
        startLevel()
        gameOn = false
        timer = 0
        timerU = true 

    end
end

function love.mousepressed(x,y,button)
    love.audio.stop(sound)
    love.audio.play(sound)
    if x > 0 and x < 800 then
        if y > 0 and y < 520 then
            print("do stuff (place selected)")
            if selectedItem ~= 0 then
                print("blah "..(math.floor(x/40)*40).." "..(math.floor(y/40)*40))
                if map[math.floor(x/40)+1][math.floor(y/40)+1] == 0 then
                    map[math.floor(x/40)+1][math.floor(y/40)+1] = selectedItem
                    selectedItem = 0
                end
            end
            
        else
            print("select from inventory")
            for i,v in ipairs(items) do
                if (x > 10+50*i and x < 10+50*(i+1)) and (y > 542 and y < 542 + 40) then
                    print("du har klickat på plats "..i.."där finns "..v)
                    if selectedItem == 0 then
                        selectedItem = tonumber(v)
                        removeReplace(i)
                        return
                    else
                        selectedItem, items[i] = items[i], selectedItem
                        selectedItem = tonumber(selectedItem)
                        items[i] = tonumber(items[i])
                        return
                    end
                    
                else
                    if selectedItem ~= 0 then
                        table.insert(items,selectedItem)
                        selectedItem = 0
                    end
                end
            end
        end
    end
end


function removeReplace(num)
    local i = num
    while items[i] ~= nil do
        items[i] = items[i+1]
        i = i + 1
    end
end



