function fall(dt)
    if p.fall == true then
        gravity.power = gravity.power + gravity.power * (2*dt)
        if gravity.power > 200 then gravity.power = 200 end

        if gravity.dir == "down" then
            p.y = p.y + (100*dt + gravity.power*dt)
        end
        if gravity.dir == "up" then
            p.y = p.y - (100*dt + gravity.power*dt)
        end
        if gravity.dir == "left" then
            p.x = p.x - (100*dt + gravity.power*dt)
        end
        if gravity.dir == "right" then
            p.x = p.x + (100*dt + gravity.power*dt)
        end
         
    end
end

function move(dt)
    if p.fall == false then
        if p.dir == "left" then
            if gravity.dir == "down" then p.xv = -100 end
            if gravity.dir == "up" then p.xv = 100 end
            if gravity.dir == "left" then p.yv = -100 end
            if gravity.dir == "right" then p.yv = 100 end
        end
        if p.dir == "right" then
            if gravity.dir == "down" then p.xv = 100 end
            if gravity.dir == "up" then p.xv = -100 end
            if gravity.dir == "left" then p.yv = 100 end
            if gravity.dir == "right" then p.yv = -100 end
        end

        p.x = p.x + p.xv*dt
        p.y = p.y + p.yv*dt

        if sideColl() then
            if p.dir == "left" and gravity.dir == "down" then
                p.x = ((math.floor(p.x/40)+1)*40)+1
                p.dir = "right"
            elseif p.dir == "right" and gravity.dir == "down" then
                p.x = ((math.floor(p.x/40))*40)-1
                p.dir = "left"
            elseif p.dir == "left" and gravity.dir == "up" then
                p.x = ((math.floor(p.x/40))*40)-1
                p.dir = "right"
            elseif p.dir == "right" and gravity.dir == "up" then
                p.x = ((math.floor(p.x/40)+1)*40)+1
                p.dir = "left"
            elseif p.dir == "left" and gravity.dir == "left" then
                p.y = ((math.floor(p.y/40)+1)*40)+1
                p.dir = "right"
            elseif p.dir == "right" and gravity.dir == "left" then
                p.y = ((math.floor(p.y/40))*40)-1
                p.dir = "left"  
            elseif p.dir == "left" and gravity.dir == "right" then
                p.y = ((math.floor(p.y/40))*40)-1
                p.dir = "right"
            elseif p.dir == "right" and gravity.dir == "right" then
                p.y = ((math.floor(p.y/40)+1)*40)+1
                p.dir = "left"
            end
        end
    end
end

function sideColl()
    local x = math.floor(p.x/40)+1
    local y = math.floor(p.y/40)+1
    
    if gravity.dire == "down" then
        y = math.floor(p.y-5/40)+1
    end
    if gravity.dire == "up" then
        y = math.floor(p.y+5/40)+1
    end
    if gravity.dire == "left" then
        x = math.floor(p.x+5/40)+1
    end
    if gravity.dire == "right" then
        x = math.floor(p.x-5/40)+1
    end
    

    if onMap(x,y) then
        if mitten(x,y) then
            if tonumber(map[x][y]) == 2 then
                --arrow up
                setGravity("up")
            
            end
            if tonumber(map[x][y]) == 4 then
                --arrow up
                setGravity("down")
            
            end
            if tonumber(map[x][y]) == 5 then
                --arrow up
                setGravity("right")
            
            end
            if tonumber(map[x][y]) == 6 then
                --arrow up
                setGravity("left")
            
            end
            if tonumber(map[x][y]) == 3 then
                --A STAR!
                --level compleated
                love.audio.stop(win)
                love.audio.play(win)
                currentMap = currentMap +1
                startLevel()
            end
        end

        if map[x][y] == 1 then
            return true
        end
    end
    return false
end

function mitten(x,y)
    local testx = p.x
    local testy = p.y

    if gravity.dir == "down" then testy = testy-p.h/2 end
    if gravity.dir == "up" then testy = testy+p.h/2 end
    if gravity.dir == "left" then testx = testx+p.w/2 end
    if gravity.dir == "right" then testx = testx-p.w/2 end

    if testx > (x-1)*40+7 and testx < (x-1)*40+33 then
        if testy > (y-1)*40+7 and testy < (y-1)*40+33 then
            return true
        end
    end
    return false
end


function checkColli(dt)
    --fallcollition
    if gravity.dir == "down" or gravity.dir == "up" then
        local x = math.floor(p.x/40)+1
        local y = math.floor(p.y/40)
        if gravity.dir == "down" then y = math.floor((p.y+2)/40)+1 end
        if gravity.dir == "up" then y = math.floor((p.y-2)/40)+1 end
        --up/down collition
        if onMap(x,y) then
            if tonumber(map[x][y]) ~= 1 then
                if mitten(x,y) then
                    if tonumber(map[x][y]) == 2 then
                        --arrow up
                        setGravity("up")
            
                    end
                    if tonumber(map[x][y]) == 4 then
                        --arrow up
                        setGravity("down")
            
                    end
                    if tonumber(map[x][y]) == 5 then
                        --arrow up
                        setGravity("right")
                    end
                    if tonumber(map[x][y]) == 6 then
                        --arrow up
                        setGravity("left")
            
                    end
                    if tonumber(map[x][y]) == 3 then
                        --A STAR!
                        --level compleated
                        love.audio.stop(win)
                        love.audio.play(win)
                        currentMap = currentMap +1
                        startLevel()
                    end
                end
                p.fall = true
            else
                p.fall = false
                if gravity.dir == "down" then p.y = y*40-41 end 
                if gravity.dir == "up" then p.y = y*40+1 end 
                gravity.power = 10
            end
        else 
            --print("you lose!")
        end
    elseif gravity.dir == "left" or gravity.dir == "right" then
        x = math.floor(p.x/40)+1
        y = math.floor(p.y/40)+1
        if gravity.dir == "left" then x = math.floor((p.x-2)/40)+1 end
        if gravity.dir == "right" then x = math.floor((p.x+2)/40)+1 end
        --collition l/r
        if onMap(x,y) then
            if tonumber(map[x][y]) ~= 1 then
                if mitten(x,y) then
                    if tonumber(map[x][y]) == 2 then
                        --arrow up
                        setGravity("up")
            
                    end
                    if tonumber(map[x][y]) == 4 then
                        --arrow up
                        setGravity("down")
            
                    end
                    if tonumber(map[x][y]) == 5 then
                        --arrow up
                        setGravity("right")
                    end
                    if tonumber(map[x][y]) == 6 then
                        --arrow up
                        setGravity("left")
            
                    end
                    if tonumber(map[x][y]) == 3 then
                        --A STAR!
                        --level compleated
                        love.audio.stop(win)
                        love.audio.play(win)
                        currentMap = currentMap +1
                        startLevel()

                    end
                end
                p.fall = true
            else
                p.fall = false
                if gravity.dir == "left" then p.x = x*40+1 end 
                if gravity.dir == "right" then p.x = x*40-41 end 
                gravity.power = 10
            end
        else
            --print("you lose!")
        end        
    end
end

function onMap(x,y)
    --are these coordinates on the map? 
    --counted in 40x40 squares
    if x >= 1 and x <= 20 then
        if y >= 1 and y <= 13 then
            return true
        end
    end
    return false
end


function setGravity(dir)
    print("Setting gravity to "..dir)
    gravity.dir = dir
    p.xv = 0
    p.xy = 0
    if dir == "down" then p.rot = 0 end
    if dir == "up" then p.rot = 180 end
    if dir == "right" then p.rot = 270 end
    if dir == "left" then p.rot = 90 end
end